package cicaprojekt;

import java.util.List;

public class Player extends PlayerBase{
	private List<ZPM> zpmContainer;
	private Box boxLifted;
	
	
	public Player(Tile startTile, Direction startDirection){
		Menu.addTab();
		System.out.println(">" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Player.Player(" + startTile + startDirection + ")");
		currentTile = startTile;
		facingDirection = startDirection; /* Be lehetne állítani egy defaultot is, nem tudom, mennyire kéne */
		System.out.println("<" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Player.Player()");
		Menu.removeTab();
	}

	public void boxLift() {
		Menu.addTab();
		System.out.println(">" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Player.boxLift()");
        boxLifted = (Box) currentTile.getAdjacentTile(facingDirection).removeItemFromTile();
		System.out.println("<" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Player.boxLift()");
		Menu.removeTab();
	}

	public void boxDrop() {
		Menu.addTab();
		System.out.println(">" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Player.boxDrop()");
		currentTile.getAdjacentTile(facingDirection).setItemOnTile(boxLifted);
		boxLifted = null;
		System.out.println("<" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Player.boxDrop()");
		Menu.removeTab();
	}
	
	public void shootStargate(Stargate stargate) {
		Menu.addTab();
		System.out.println(">" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Player.shootStargate(stargate)");
		this.currentTile.getAdjacentTile(facingDirection).spawnStargate(stargate, facingDirection);
		System.out.println("<" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Player.shootStargate()");
		Menu.removeTab();
	}
}
